#ifndef EFL_GENERATED_ECORE_AUDIO_IN_HH
#define EFL_GENERATED_ECORE_AUDIO_IN_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_in.eo.h"
}

#include "ecore_audio.eo.hh"

struct ecore_audio_in
      : ecore_audio
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_in(Eo* eo)
      : ecore_audio(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_in(std::nullptr_t)
      : ecore_audio(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   ecore_audio_in(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_in(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_in(ecore_audio_in const& other)
      : ecore_audio(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_in() {}

   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
   }

   /// @brief Get the the preloaded state of the input
   ///
   /// @since 1.8
   ///
   /// @param preloaded 
   ///
   bool preloaded_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_preloaded_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Set the preloaded state of the input
   ///
   /// @since 1.8
   ///
   /// @param preloaded 
   ///
   void preloaded_set(bool preloaded_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_preloaded_set(efl::eolian::to_c(preloaded_)));
   }

   /// @brief Set the length of the input
   ///
   /// This function is only implemented by some classes
   /// (i.e. ECORE_AUDIO_OBJ_IN_TONE_CLASS)
   ///
   /// @since 1.8
   ///
   /// @param length 
   ///
   void length_set(double length_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_length_set(length_));
   }

   /// @brief Get the playback speed of the input.
   ///
   /// @since 1.8
   ///
   /// @param speed 
   ///
   double speed_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_speed_get());
      return _tmp_ret;
   }

   /// @brief Set the playback speed of the input.
   ///
   /// @since 1.8
   ///
   /// @param speed 
   ///
   void speed_set(double speed_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_speed_set(speed_));
   }

   /// @brief Get the he sample-rate of the input
   ///
   /// @since 1.8
   ///
   /// @param samplerate 
   ///
   int samplerate_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_samplerate_get());
      return _tmp_ret;
   }

   /// @brief Set the sample-rate of the input
   ///
   /// @since 1.8
   ///
   /// @param samplerate 
   ///
   void samplerate_set(int samplerate_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_samplerate_set(samplerate_));
   }

   /// @brief Get the amount of channels the input has
   ///
   /// @since 1.8
   ///
   /// @param channels 
   ///
   int channels_get() const
   {
      int _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_channels_get());
      return _tmp_ret;
   }

   /// @brief Set the amount of channels the input has
   ///
   /// @since 1.8
   ///
   /// @param channels 
   ///
   void channels_set(int channels_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_channels_set(channels_));
   }

   /// @brief Get the looped state of the input
   ///
   /// @since 1.8
   ///
   /// @param looped 
   ///
   bool looped_get() const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_looped_get());
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Set the looped state of the input
   ///
   /// If the input is looped and reaches the end it will start from the
   /// beginning again. At the same time the event @ref ECORE_AUDIO_EV_IN_LOOPED
   /// will be emitted
   ///
   /// @since 1.8
   ///
   /// @param looped 
   ///
   void looped_set(bool looped_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_looped_set(efl::eolian::to_c(looped_)));
   }

   /// @brief Get the length of the input
   ///
   /// @since 1.8
   ///
   /// @param length 
   ///
   double length_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_length_get());
      return _tmp_ret;
   }

   /// @brief Get the output that this input is attached to
   ///
   /// @since 1.8
   ///
   /// @param output 
   ///
   efl::eo::base output_get() const
   {
      Eo * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_output_get());
      return efl::eolian::to_cxx<efl::eo::base>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Get the remaining time of the input
   ///
   /// @since 1.8
   ///
   /// @param remaining 
   ///
   double remaining_get() const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_remaining_get());
      return _tmp_ret;
   }

   /// @brief Read from the input
   ///
   /// @since 1.8
   ///
   /// @param buf 
   /// @param len 
   ///
   ssize_t read(void * buf_, size_t len_) const
   {
      ssize_t _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read(buf_, len_));
      return _tmp_ret;
   }

   /// @brief Internal read function
   ///
   /// @since 1.8
   ///
   /// @param buf 
   /// @param len 
   ///
   ssize_t read_internal(void * buf_, size_t len_) const
   {
      ssize_t _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
      return _tmp_ret;
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_in_looped_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_LOOPED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_LOOPED );
   }

   template <typename T>
   void
   callback_in_looped_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_LOOPED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_in_stopped_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_STOPPED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_STOPPED );
   }

   template <typename T>
   void
   callback_in_stopped_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_STOPPED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_in_samplerate_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED );
   }

   template <typename T>
   void
   callback_in_samplerate_changed_call(T* info)
   {
      eo_do(_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED, info));
   }
   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_IN_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(ECORE_AUDIO_IN_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _ecore_audio_in_vio_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
{
   static_cast<T*>(self->this_)->vio_set(vio_, data_, free_func_);
}

template <typename T>
bool _ecore_audio_in_preloaded_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->preloaded_get();
}

template <typename T>
void _ecore_audio_in_preloaded_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool preloaded_)
{
   static_cast<T*>(self->this_)->preloaded_set(efl::eolian::to_cxx<bool>(preloaded_, std::tuple<std::false_type>()));
}

template <typename T>
void _ecore_audio_in_length_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double length_)
{
   static_cast<T*>(self->this_)->length_set(length_);
}

template <typename T>
double _ecore_audio_in_speed_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->speed_get();
}

template <typename T>
void _ecore_audio_in_speed_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double speed_)
{
   static_cast<T*>(self->this_)->speed_set(speed_);
}

template <typename T>
int _ecore_audio_in_samplerate_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->samplerate_get();
}

template <typename T>
void _ecore_audio_in_samplerate_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int samplerate_)
{
   static_cast<T*>(self->this_)->samplerate_set(samplerate_);
}

template <typename T>
int _ecore_audio_in_channels_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->channels_get();
}

template <typename T>
void _ecore_audio_in_channels_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, int channels_)
{
   static_cast<T*>(self->this_)->channels_set(channels_);
}

template <typename T>
bool _ecore_audio_in_looped_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->looped_get();
}

template <typename T>
void _ecore_audio_in_looped_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eina_Bool looped_)
{
   static_cast<T*>(self->this_)->looped_set(efl::eolian::to_cxx<bool>(looped_, std::tuple<std::false_type>()));
}

template <typename T>
double _ecore_audio_in_length_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->length_get();
}

template <typename T>
efl::eo::base _ecore_audio_in_output_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->output_get();
}

template <typename T>
double _ecore_audio_in_remaining_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->remaining_get();
}

template <typename T>
ssize_t _ecore_audio_in_read_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, void * buf_, size_t len_)
{
   return static_cast<T*>(self->this_)->read(buf_, len_);
}

template <typename T>
ssize_t _ecore_audio_in_read_internal_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, void * buf_, size_t len_)
{
   return static_cast<T*>(self->this_)->read_internal(buf_, len_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_in >
{
   template <typename T>
   struct type
   {
      virtual void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      virtual bool preloaded_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_preloaded_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void preloaded_set(bool preloaded_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_preloaded_set(efl::eolian::to_c(preloaded_)));
      }

      virtual void length_set(double length_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_length_set(length_));
      }

      virtual double speed_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_speed_get());
            return _tmp_ret;
      }

      virtual void speed_set(double speed_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_speed_set(speed_));
      }

      virtual int samplerate_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_samplerate_get());
            return _tmp_ret;
      }

      virtual void samplerate_set(int samplerate_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_samplerate_set(samplerate_));
      }

      virtual int channels_get()
      {
         int _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_channels_get());
            return _tmp_ret;
      }

      virtual void channels_set(int channels_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_channels_set(channels_));
      }

      virtual bool looped_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_looped_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual void looped_set(bool looped_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_looped_set(efl::eolian::to_c(looped_)));
      }

      virtual double length_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_length_get());
            return _tmp_ret;
      }

      virtual efl::eo::base output_get()
      {
         Eo * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_output_get());
            return efl::eolian::to_cxx<efl::eo::base>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual double remaining_get()
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_remaining_get());
            return _tmp_ret;
      }

      virtual ssize_t read(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_read(buf_, len_));
            return _tmp_ret;
      }

      virtual ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_in >
{
   static const int value = 17;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_in>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_in_vio_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_vio_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_in_preloaded_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_preloaded_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_in_preloaded_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_preloaded_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_ecore_audio_in_length_set_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_length_set);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_ecore_audio_in_speed_get_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_speed_get);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   ops[5].func = reinterpret_cast<void*>(& ::_ecore_audio_in_speed_set_wrapper<T>);
   ops[5].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_speed_set);
   ops[5].op = EO_OP_OVERRIDE;
   ops[5].op_type = EO_OP_TYPE_REGULAR;
   ops[5].doc = NULL;

   ops[6].func = reinterpret_cast<void*>(& ::_ecore_audio_in_samplerate_get_wrapper<T>);
   ops[6].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_samplerate_get);
   ops[6].op = EO_OP_OVERRIDE;
   ops[6].op_type = EO_OP_TYPE_REGULAR;
   ops[6].doc = NULL;

   ops[7].func = reinterpret_cast<void*>(& ::_ecore_audio_in_samplerate_set_wrapper<T>);
   ops[7].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_samplerate_set);
   ops[7].op = EO_OP_OVERRIDE;
   ops[7].op_type = EO_OP_TYPE_REGULAR;
   ops[7].doc = NULL;

   ops[8].func = reinterpret_cast<void*>(& ::_ecore_audio_in_channels_get_wrapper<T>);
   ops[8].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_channels_get);
   ops[8].op = EO_OP_OVERRIDE;
   ops[8].op_type = EO_OP_TYPE_REGULAR;
   ops[8].doc = NULL;

   ops[9].func = reinterpret_cast<void*>(& ::_ecore_audio_in_channels_set_wrapper<T>);
   ops[9].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_channels_set);
   ops[9].op = EO_OP_OVERRIDE;
   ops[9].op_type = EO_OP_TYPE_REGULAR;
   ops[9].doc = NULL;

   ops[10].func = reinterpret_cast<void*>(& ::_ecore_audio_in_looped_get_wrapper<T>);
   ops[10].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_looped_get);
   ops[10].op = EO_OP_OVERRIDE;
   ops[10].op_type = EO_OP_TYPE_REGULAR;
   ops[10].doc = NULL;

   ops[11].func = reinterpret_cast<void*>(& ::_ecore_audio_in_looped_set_wrapper<T>);
   ops[11].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_looped_set);
   ops[11].op = EO_OP_OVERRIDE;
   ops[11].op_type = EO_OP_TYPE_REGULAR;
   ops[11].doc = NULL;

   ops[12].func = reinterpret_cast<void*>(& ::_ecore_audio_in_length_get_wrapper<T>);
   ops[12].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_length_get);
   ops[12].op = EO_OP_OVERRIDE;
   ops[12].op_type = EO_OP_TYPE_REGULAR;
   ops[12].doc = NULL;

   ops[13].func = reinterpret_cast<void*>(& ::_ecore_audio_in_output_get_wrapper<T>);
   ops[13].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_output_get);
   ops[13].op = EO_OP_OVERRIDE;
   ops[13].op_type = EO_OP_TYPE_REGULAR;
   ops[13].doc = NULL;

   ops[14].func = reinterpret_cast<void*>(& ::_ecore_audio_in_remaining_get_wrapper<T>);
   ops[14].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_remaining_get);
   ops[14].op = EO_OP_OVERRIDE;
   ops[14].op_type = EO_OP_TYPE_REGULAR;
   ops[14].doc = NULL;

   ops[15].func = reinterpret_cast<void*>(& ::_ecore_audio_in_read_wrapper<T>);
   ops[15].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_read);
   ops[15].op = EO_OP_OVERRIDE;
   ops[15].op_type = EO_OP_TYPE_REGULAR;
   ops[15].doc = NULL;

   ops[16].func = reinterpret_cast<void*>(& ::_ecore_audio_in_read_internal_wrapper<T>);
   ops[16].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_read_internal);
   ops[16].op = EO_OP_OVERRIDE;
   ops[16].op_type = EO_OP_TYPE_REGULAR;
   ops[16].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_in >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_audio_in >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::ecore_audio_in>
{
   template <typename U>
   struct type
   {
      operator ::ecore_audio_in() const
      {
         return ::ecore_audio_in(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      bool preloaded_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_preloaded_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void preloaded_set(bool preloaded_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_preloaded_set(efl::eolian::to_c(preloaded_)));
      }

      void length_set(double length_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_length_set(length_));
      }

      double speed_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_speed_get());
            return _tmp_ret;
      }

      void speed_set(double speed_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_speed_set(speed_));
      }

      int samplerate_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_samplerate_get());
            return _tmp_ret;
      }

      void samplerate_set(int samplerate_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_samplerate_set(samplerate_));
      }

      int channels_get()
      {
         int _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_channels_get());
            return _tmp_ret;
      }

      void channels_set(int channels_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_channels_set(channels_));
      }

      bool looped_get()
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_looped_get());
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      void looped_set(bool looped_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_looped_set(efl::eolian::to_c(looped_)));
      }

      double length_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_length_get());
            return _tmp_ret;
      }

      efl::eo::base output_get()
      {
         Eo * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_output_get());
            return efl::eolian::to_cxx<efl::eo::base>(_tmp_ret, std::tuple<std::false_type>());
      }

      double remaining_get()
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_remaining_get());
            return _tmp_ret;
      }

      ssize_t read(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read(buf_, len_));
            return _tmp_ret;
      }

      ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   template <typename F>
   ::efl::eo::signal_connection
   callback_in_looped_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_LOOPED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_LOOPED );
   }

   template <typename T>
   void
   callback_in_looped_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_LOOPED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_in_stopped_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_STOPPED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_STOPPED );
   }

   template <typename T>
   void
   callback_in_stopped_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_STOPPED, info));
   }
   template <typename F>
   ::efl::eo::signal_connection
   callback_in_samplerate_changed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::move(callback_)) );
      eo_do(static_cast<U*>(this)->_eo_ptr(),
            eo_event_callback_priority_add
            (ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED, priority_,
            &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, static_cast<U*>(this)->_eo_ptr(), &efl::eo::_detail::event_callback<::ecore_audio_in, function_type>,
         ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED );
   }

   template <typename T>
   void
   callback_in_samplerate_changed_call(T* info)
   {
      eo_do(static_cast<U*>(this)->_eo_ptr(), eo_event_callback_call
            (ECORE_AUDIO_IN_EVENT_IN_SAMPLERATE_CHANGED, info));
   }
   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_in>)
{
   return (ECORE_AUDIO_IN_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_IN_HH

